/' Copyright (c) 2007 Scott Lembcke
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 '/

type cpDampedSpringPTR as cpDampedSpring ptr

type cpDampedSpringForceFunc as function cdecl( byval as cpConstraint ptr, byval as cpFloat ) as cpFloat

declare function cpDampedSpringGetClass cdecl alias "cpDampedSpringGetClass" () as const cpConstraintClass ptr

type cpDampedSpring
	as cpConstraint	constraint
	as cpVect		anchr1, anchr2
	as cpFloat		restLength, stiffness, damping
	as cpDampedSpringForceFunc	springForceFunc
	
	as cpFloat		target_vrn, w_coef
	as cpVect		r1, r2
	as cpFloat		nMass
	as cpVect		n
end type

declare function cpDampedSpringAlloc cdecl alias "cpDampedSpringAlloc" () as cpDampedSpring ptr
declare function cpDampedSpringInit cdecl alias "cpDampedSpringInit" ( byval as cpDampedSpring ptr, byval as cpBody ptr, byval as cpBody ptr, byval as cpVect, byval as cpVect, byval as cpFloat, byval as cpFloat, byval as cpFloat ) as cpDampedSpring ptr
declare function cpDampedSpringNew cdecl alias "cpDampedSpringNew" ( byval as cpBody ptr, byval as cpBody ptr, byval as cpVect, byval as cpVect, byval as cpFloat, byval as cpFloat, byval as cpFloat ) as cpConstraint ptr

CP_DefineConstraintProperty(cpDampedSpring, cpVect, anchr1, Anchr1)
CP_DefineConstraintProperty(cpDampedSpring, cpVect, anchr2, Anchr2)
CP_DefineConstraintProperty(cpDampedSpring, cpFloat, restLength, RestLength)
CP_DefineConstraintProperty(cpDampedSpring, cpFloat, stiffness, Stiffness)
CP_DefineConstraintProperty(cpDampedSpring, cpFloat, damping, Damping)
CP_DefineConstraintProperty(cpDampedSpring, cpDampedSpringForceFunc, springForceFunc, SpringForceFunc)

